;; 
;;  uim-init.el - variables and initialize routines for uim.el
;;
;;  Copyright (c) 2005, Konosuke Watanabe <nosuke@csc.ne.jp>
;;  All rights reserved.
;;
;;  $Id: uim-init.el,v 1.9 2005/07/24 15:42:52 nosuke Exp $
;;
;;  Redistribution and use in source and binary forms, with or
;;  without modification, are permitted provided that the
;;  following conditions are met:
;;
;;  1. Redistributions of source code must retain the above
;;     copyright notice, this list of conditions and the
;;     following disclaimer.
;;  2. Redistributions in binary form must reproduce the above
;;     copyright notice, this list of conditions and the
;;     following disclaimer in the documentation and/or other
;;     materials provided with the distribution.
;;  3. Neither the name of authors nor the names of its
;;     contributors may be used to endorse or promote products
;;     derived from this software without specific prior written
;;     permission.
;;
;;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
;;  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
;;  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
;;  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
;;  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
;;  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
;;  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
;;  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;;  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
;;  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
;;  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;;  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;;


;;; ΤǶ̤ѿ

(defconst uim-el-version "0.0.3")

(defvar uim-xemacs (featurep 'xemacs))
(defvar uim-emacs (string-match "^GNU Emacs" (emacs-version)))

;;; uim-agentΤΥѥ
(defvar uim-agent "uim-agent")
;;; uim-agentνʸ
(defvar uim-default-encoding nil)

;;; ƸΥѥ᡼бꥹ
(defvar uim-lang-code-alist nil)

(defconst uim-lang-code
  '(
    ("Japanese" "Japanese" euc-jp "EUC-JP")
    ("Korean" "Korean" euc-kr "EUC-KR")
    ("Chinese (Simplified)" "Chinese-GB" gb2312 "GB2312")
    ("Chinese (Traditional)" "Chinese-BIG5" big5 "BIG5")
    ("Chinese" "Chinese-GB" gb2312 "GB2312") ;; äƤ롩
    ("Vietnamese" "Vietnamese" viscii "VISCII")
    ("Latin" "Latin-1" iso-8859-1 "ISO-8859-1")
    ("Thai" "Thai" thai-tis620 "TIS-620")
    ("Greek" "Greek" iso-8859-7 "ISO-8859-7" )
    ("Hebrew" "Hebrew" iso-8859-8 "ISO-8859-8")
    ("Laothian" "Lao" lao "MULELAO-1")
    ("Croatian" "Latin-2" iso-8859-2 "ISO-8859-2")
    ("Slovenian" "Latin-2" iso-8859-2 "ISO-8859-2") ;; ISO-8859-16?
    ("Serbian"  "Latin-2" iso-8859-2 "ISO-8859-2")
    ("Russian" "Cyrillic-ISO" iso-8859-5 "ISO-8859-5")
    ("Other"   "ASCII" iso-8859-1 "ISO-8859-1")
    ))
    


;;; ޥå״Ϣ
(defvar uim-mode-map nil)
(defvar uim-mode-meta-map nil)
(defvar uim-preedit-map nil)
(defvar uim-preedit-meta-map nil)

;;; ⡼ɥ饤ʸ
(defvar uim-mode-line-string " U")

;;; uim-agentϢ
(defvar uim-agent-process nil)             ;; ץ
(defvar uim-agent-buffer nil)              ;; Хåե
(defconst uim-agent-buffer-name " *uim*")  ;; Хåե̾

;;; ѿȽͤФˤʤäꥹ
(defvar uim-local-var '())


;; ॢȴϢ()
(defvar uim-agent-timeout 3)
(defvar uim-agent-accept-timeout 50)


;;; Ѵ򥤥饤ɽ뤫(ǥե)
;;;  nil̵ ʳͭ
(defvar uim-candidate-display-inline-default nil)


;;; Emacs-nwǾ夲ݤ˥ץꥨǥåEscͥ褵
;;; M-ΥХɤͥ褵뤫
(defvar uim-use-single-escape-on-terminal t)


;;; Ѵ򥤥饤ɽǾ
(defconst uim-candidate-minimum-width 8)

;; ǥեȤΥ󥸥̾
(defvar uim-default-im-engine nil)
(defvar uim-default-im-prop nil)

;;; ƥȤΥǥեȥ󥸥 
;;;  agent֤Ƥ
(defvar uim-context-default-im-engine nil)

;; Ȥ륨󥸥Υꥹ
(defvar uim-im-list nil)

;; ߥեƤUimѤХåե
(defvar uim-focused-buffer nil)
;; ľΥХåե
(defvar uim-recent-buffer (current-buffer))

;; ƥIDѿ
(defvar uim-context-id-max 1)
(defvar uim-context-id-recycle '())

;; ߥƥȤѤƤХåե̾
(defvar uim-using-buffer '())

;;; faceϢ
;;;  ץꥨǥå
(defvar uim-preedit-face nil)
(defvar uim-preedit-underline-face nil)
(defvar uim-preedit-highlight-face nil)
(defvar uim-preedit-highlight-underline-face nil)

;;;  ץꥨǥåȤΥѥ졼
(defvar uim-separator-face nil)

;;;  Ѵ
(defvar uim-candidate-odd-face nil)
(defvar uim-candidate-even-face nil)
(defvar uim-candidate-selected-face nil)
(defvar uim-candidate-nth-face nil)


;;; agentȤδ֤̿Υꥢֹ
(defvar uim-communication-serial-number 0)

(defvar uim-leim-inputmethod-alist '())

;;; Хåեѿޥ
(defmacro uim-deflocalvar (var default &optional documentation)
  `(progn
     (defvar ,var ,default
       (format "%s (local\)" ,documentation))
     (setq uim-local-var (cons (cons ',var ,default) uim-local-var))
     (make-variable-buffer-local ',var)))

;; ХåեΥƥID (0̤갷)
(uim-deflocalvar uim-context-id 0)

;; ΥХåեΥƥȤǻȤƤ륨󥸥
(uim-deflocalvar uim-current-im-engine nil) 


(uim-deflocalvar uim-current-prop-label nil)

;; ΥХåեΥƥȤΥ󥳡ǥ
(uim-deflocalvar uim-context-encoding 
		 (nth 2 (assoc current-language-environment uim-lang-code)))


;; ޥʡ⡼
(uim-deflocalvar uim-mode nil)

;; leim
(uim-deflocalvar uim-leim-active-p nil)

;; ߤΥץѥƥ(ɽ)
(uim-deflocalvar uim-prop-string nil)
(uim-deflocalvar uim-prop-string-buffer nil)

;; ⡼ɥ饤
(uim-deflocalvar uim-mode-line-initialized nil)

;; ץꥨǥåȴϢ

;;  ץꥨǥåɽǡ
(uim-deflocalvar uim-preedit nil) 
;;  ץꥨǥåȤɽ¸ߤ뤫(ɽƤ뤫ɤ)
(uim-deflocalvar uim-preedit-exist nil)

(uim-deflocalvar uim-preedit-start 0)
(uim-deflocalvar uim-preedit-end 0)
(uim-deflocalvar uim-preedit-cursor 0)
(uim-deflocalvar uim-preedit-cursor-ol nil)

;;  ץꥨǥåȤΥХ쥤
(uim-deflocalvar uim-preedit-overlays '())


;; ѴϢ

;;  Ѵɽǡ
(uim-deflocalvar uim-candidate nil)
;;  Ѵɽ¸ߤ뤫
(uim-deflocalvar uim-candidate-exist nil)
;;  Ѵ(§ΰ첾۹Բɽ)
(uim-deflocalvar uim-candidate-start 0)
;;  ץꥨǥåȤĹƹԤޤ֤ƤݤˡԴ֤򳫤뤫
(uim-deflocalvar uim-candidate-ofs 0)
;;  ѴѤΥǡ
(uim-deflocalvar uim-candidate-original '())
;;  ѴΥХ쥤
(uim-deflocalvar uim-candidate-overlays '())

;;  Ѵɽ
(uim-deflocalvar uim-candidate-display-inline nil)


;;; undoꥹ
(uim-deflocalvar uim-buffer-undo-list nil)
(uim-deflocalvar uim-buffer-undo-list-saved nil)

;;; ץꥨǥå/Ѵundoꥹ
(uim-deflocalvar uim-special-undo-list nil)

;;; եȥå⡼
(uim-deflocalvar uim-font-lock-mode nil)
(uim-deflocalvar uim-font-lock-verbose nil)

;;; Window
(uim-deflocalvar uim-window-start nil)

;;; inhibit
(uim-deflocalvar uim-inhibit-read-only nil)


(uim-deflocalvar uim-facelist nil)

;;; ޥɽ
(uim-deflocalvar uim-command-result nil)

;;; ХåեΥ꡼ɥ꡼
(uim-deflocalvar uim-buffer-readonly-state nil)





;; ޥåװ
(uim-deflocalvar uim-keymap-temp nil)

;; agentνϤΥǥɤ˻Ȥ󥳡ǥ
(uim-deflocalvar uim-decoding-code nil)

;; Ϣν
(defun uim-init-lang ()
  (setq uim-lang-code-alist
	(mapcar (lambda (x)
		  (list (nth 0 x)
			(cons 'uim-lang (nth 0 x))
			(cons 'emacs-lang (nth 1 x))
			(cons 'emacs-code (nth 2 x))
			(cons 'uim-code (nth 3 x))))
		uim-lang-code))
  )


(defun uim-init-face ()
  ;;; face
  ;;; ץꥨǥåѤface

  ;; Ρޥ
  (copy-face 'default 'uim-preedit-face)

  (copy-face 'uim-preedit-face 'uim-preedit-underline-face)
  (set-face-underline-p        'uim-preedit-underline-face t)

  ;; ϥ饤
  (copy-face 'default  'uim-preedit-highlight-face)
  (set-face-foreground 'uim-preedit-highlight-face "White")
  (set-face-background 'uim-preedit-highlight-face "Blue3")

  (copy-face 'uim-preedit-highlight-face 'uim-preedit-highlight-underline-face)
  (set-face-underline-p                  'uim-preedit-highlight-underline-face t)

  ;; ѥ졼
  (copy-face 'default 'uim-separator-face)
  (set-face-foreground 'uim-separator-face "LightSkyBlue4")

  ;; 
  (copy-face 'default 'uim-candidate-odd-face)
  (set-face-foreground 'uim-candidate-odd-face "blue")
  (set-face-background 'uim-candidate-odd-face "snow1")

  ;; 
  (copy-face 'default 'uim-candidate-even-face)
  (set-face-foreground 'uim-candidate-even-face "blue")
  (set-face-background 'uim-candidate-even-face "snow2")

;; ե
  (copy-face 'default  'uim-candidate-selected-face)
  (set-face-foreground 'uim-candidate-selected-face "blue")
  (set-face-background 'uim-candidate-selected-face "snow3")
  ;(set-face-bold-p     'uim-candidate-selected-face t)

  ;; θȸߤֹ
  (copy-face 'default 'uim-candidate-nth-face)
  (set-face-foreground 'uim-candidate-nth-face "blue")
  (set-face-background 'uim-candidate-nth-face "lavender") )



(defun uim-init-minor-mode ()
  ;; ޥʡ⡼
  ;;  ޥʡ⡼̵äɲ
  (if (not (assq 'uim-mode minor-mode-alist))
      (setq minor-mode-alist
	    (cons
	     (cons 'uim-mode '(uim-mode-line-string))
	     minor-mode-alist)))

  ;;  ޥʡ⡼ɤΥޥåɲ
  (if (not (assq 'uim-mode minor-mode-map-alist))
      (setq minor-mode-map-alist
	    (cons
	     (cons 'uim-mode uim-mode-map)
	     minor-mode-map-alist))))


(defun uim-init-agent ()
  ;; get IM engines' list
  (uim-get-im-list)

  ;; set Uim side encoding to agent
  (let ((im-list (cdr uim-im-list)))
    (while im-list
      ;; cdar exists when im has valid encoding
      (if (cdar im-list)
	  (uim-set-encoding (caar im-list)))
      (setq im-list (cdr im-list)))))


(uim-init-lang)
(uim-init-face)
(uim-init-minor-mode)

;; ޥåפƤ
(require 'uim-keymap)
(uim-init-keymap)

(if uim-xemacs
    (progn
      (require 'overlay)
      (load "mule-util")
      ))

(provide 'uim-init)
