;; 
;;  uim-key.el - key related functions of uim.el
;;
;;  Copyright (c) 2005, Konosuke Watanabe <nosuke@csc.ne.jp>
;;  All rights reserved.
;;
;;  $Id: uim-key.el,v 1.6 2005/07/19 10:38:02 nosuke Exp $
;;
;;  Redistribution and use in source and binary forms, with or
;;  without modification, are permitted provided that the
;;  following conditions are met:
;;
;;  1. Redistributions of source code must retain the above
;;     copyright notice, this list of conditions and the
;;     following disclaimer.
;;  2. Redistributions in binary form must reproduce the above
;;     copyright notice, this list of conditions and the
;;     following disclaimer in the documentation and/or other
;;     materials provided with the distribution.
;;  3. Neither the name of authors nor the names of its
;;     contributors may be used to endorse or promote products
;;     derived from this software without specific prior written
;;     permission.
;;
;;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
;;  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
;;  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
;;  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
;;  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
;;  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
;;  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
;;  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;;  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
;;  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
;;  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;;  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;;


;; ٥ȥ֤ФȤ
;; ʤ (this-command-keys)
;;  XEmacsǤMetaäƤ2ʬ뤳ȤϤʤ餷
(defun uim-this-command-keys-vector ()
  (if uim-xemacs
      (this-command-keys)
    (this-command-keys-vector)))



;;; ǸΥȥ򸡽
(defun uim-last-onestroke-key (keyvec)
  (let ((len (length keyvec)))
    (cond ((= len 1)
 	   keyvec 
	   )
 	  ((>= len 2)
 	   (let ( (last2 (aref keyvec (- len 2)) )
 		  (last (aref keyvec (- len 1)) ) )
 	     (if (eq last2 27)
 		 (vector last2 last)
 	       (vector last)))))))


;; ˥Хɤ줿ؿ
(defun uim-getbind (keyvec)
  (let (bind)
    (uim-disable-keymap-temporally)
    (unwind-protect
	(setq bind (key-binding (uim-last-onestroke-key keyvec)))
      (uim-enable-keymap-temporally)
      )
    bind
    ))



;; uimϤ롼äƤν
(defun uim-process-keyvec (keyvec)
  (let ( (bind (uim-getbind keyvec))
	 (post-exec nil) )

    (uim-disable-keymap-temporally)
    
    (unwind-protect
	(cond ((eq bind 'self-insert-command)
	       ;; self-insert-commandξưü
	       (command-execute keyvec)
	       (if (= ?\) (char-syntax (aref keyvec 0)))
		   (blink-matching-open)
		 ))
	      ((and uim-xemacs
		    ;; xemacsˤisearchunwind-protecγǤʤȥ顼ˤʤ
		    (string-match "^isearch-" (format "%s" bind)))
	       (setq post-exec t))
	      (bind
	       (command-execute bind))

;	      ((and (= 1 (length (car (append keyvec nil))))
;		    (key-binding  (car (aref keyvec 0)) function-key-map)
;		    (not (equal keyvec [(escape)])))
;	       (command-execute keyvec))

	      (t (undefined)))
      (uim-enable-keymap-temporally))

    (if post-exec (funcall bind))

    )
  )


(provide 'uim-key)


