; 
;;  uim-leim.el - leim related functions of uim.el
;;
;;  Copyright (c) 2005, Konosuke Watanabe <nosuke@csc.ne.jp>
;;  All rights reserved.
;;
;;  $Id: uim-leim.el,v 1.6 2005/07/24 01:18:52 nosuke Exp $
;;
;;  Redistribution and use in source and binary forms, with or
;;  without modification, are permitted provided that the
;;  following conditions are met:
;;
;;  1. Redistributions of source code must retain the above
;;     copyright notice, this list of conditions and the
;;     following disclaimer.
;;  2. Redistributions in binary form must reproduce the above
;;     copyright notice, this list of conditions and the
;;     following disclaimer in the documentation and/or other
;;     materials provided with the distribution.
;;  3. Neither the name of authors nor the names of its
;;     contributors may be used to endorse or promote products
;;     derived from this software without specific prior written
;;     permission.
;;
;;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
;;  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
;;  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
;;  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
;;  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
;;  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
;;  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
;;  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;;  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
;;  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
;;  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;;  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;;

(require 'uim)

(defun uim-leim-make-im-name (im)
  (let (lang)
    (setq lang (downcase (uim-get-emacs-lang im)))
    (concat lang "-" im "-uim")))

(defun uim-leim-init ()
  (uim-get-im-list)
  ;; input-method-alistɲä
  ;; (list-input-methods)ɽ 
  ;;  ˤʤȡset-input-methodǸƤ٤ʤ
  (let ((im-list (cdr uim-im-list)) lang name im)
    (while im-list
      (setq name (caar im-list))
      (setq lang (cdr (assoc 'emacs-lang (cdar im-list))))

      (when (and name lang)
	(setq im (uim-leim-make-im-name name))
;	(setq im (concat (downcase lang) "-" name "-uim"))
	(register-input-method im lang 'uim-leim-activate "[Uim]"
			       (concat "Uim " name))

      
      ;;; ( japanese-anthy-uim . anthy ) ߤʥꥹ
	(setq uim-leim-inputmethod-alist (cons (cons im name) uim-leim-inputmethod-alist)))
      (setq im-list (cdr im-list)))))



(uim-leim-init)



;; leim

;; language-info-alist
;; current-language-environment

;; language-info-alistͤ򹹿
;; ä塤set-language-environment
;(set-language-info "Japanese" 'input-method "Japanese-uim")

;; ʲϡ
;(setq default-input-method "japanese-uim")

;; ꤷinput-methodϡset-input-methodƤФʤѤʤߤ
; set-input-methodƤ֤ȡdefault-input-methodꤵ

;(if (and (boundp 'default-input-method)
;         (not default-input-method))
;    (setq default-input-method "japanese-uim"))




;;
;;
;; leim  inactivate
;;
(defun uim-leim-inactivate ()
  (setq uim-leim-active-p nil)
  (uim-mode-off))


;;
;; leim  activate
;;
;;  namejapanese-anthy-uim Ȥ
;;   anthyʬߤ
;; 
(defun uim-leim-activate (&optional name)
  (let (im)
    (setq inactivate-current-input-method-function 'uim-leim-inactivate)

    ;; Japanese-.*-uim.*ΤȤФ
    (setq im (cdr (assoc name uim-leim-inputmethod-alist)))

    (if (uim-mode-on)
	(progn
	  ;; IMnameбΤѹ
	  ;; κݡѹä硤ץ֤Υ󥳡ǥ󥰤
	  ;; ѹɬפ

	  ;; ߤΥƥȤͤȡleim줫ꤷ褦ȤƤ
	  ;; IMפʤΤߡchangeԤ
	  (if (not (equal im uim-current-im-engine))
	      (uim-change-im uim-context-id im))

	  (setq uim-leim-active-p t)))))

;; toggle-input-methodϥХåե񤱤Ȥˤͭ
(defadvice toggle-input-method (around uim-toggle-input-method-around activate)
  (if buffer-read-only
      (message "This buffer is read-only.")
    ad-do-it))


(defun uim-leim-reset ()
  (if uim-leim-active-p
      (inactivate-input-method)))

(add-hook 'change-major-mode-hook 'uim-leim-reset)
  
(provide 'uim-leim)
