;; 
;;  uim-util.el - utility functions for uim.el
;;
;;  Copyright (c) 2005, Konosuke Watanabe <nosuke@csc.ne.jp>
;;  All rights reserved.
;;
;;  $Id: uim-util.el,v 1.5 2005/07/18 02:49:15 nosuke Exp $
;;
;;  Redistribution and use in source and binary forms, with or
;;  without modification, are permitted provided that the
;;  following conditions are met:
;;
;;  1. Redistributions of source code must retain the above
;;     copyright notice, this list of conditions and the
;;     following disclaimer.
;;  2. Redistributions in binary form must reproduce the above
;;     copyright notice, this list of conditions and the
;;     following disclaimer in the documentation and/or other
;;     materials provided with the distribution.
;;  3. Neither the name of authors nor the names of its
;;     contributors may be used to endorse or promote products
;;     derived from this software without specific prior written
;;     permission.
;;
;;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
;;  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
;;  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
;;  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
;;  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
;;  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
;;  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
;;  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;;  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
;;  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
;;  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;;  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;;


;;; ʪƬ顤targetޤǤεΥ
(defun uim-relative-vertical-count (target)
  (let (base (i 1))
    (save-excursion
      (goto-char target)
      (beginning-of-line)
      (setq base (point))
      (catch 'rv-loop
	(while t ;; ֤ˤޤǲ˰ư
	  (goto-char base)
	  (if (> i (vertical-motion i))
	      ;;; iưȤiưʤä硤˥Хåե
	      (progn
		(setq i (- i 1))
		(throw 'rv-loop t)))
	  (if (= (point) target)
	      ;;; iư礦ŪϤƱä硤Υi
	      (throw 'rv-loop t))
	  (if (> (point) target)
	      ;;; iư顤ŪϤۤ
	      (progn
		(setq i (- i 1)) ;; СƤ1
		(throw 'rv-loop t)))
	  (setq i (+ i 1)))))
    i  ;;; 줬ľΥˤʤ
    ))



;; vertical-motion
(defun uim-vertical-motion-exec (n)
  (let (start base (i 1) (over nil) able)
    (setq start (point))
    ;;; startʪԤƬοľΥ
    (setq i (uim-relative-vertical-count start))
    (beginning-of-line) ;; Ƭ
    (- (vertical-motion (+ i n)) i ) ;; nԿʤ
    ;; ʤȤiФˤϤʤΤǡͤi
    ))


;; vertical-motionưʤСǤϼ٤Τư
(defun uim-vertical-motion (n)
  (if (and (string< "21" emacs-version)
	   (or (string< emacs-version "21.3.1")
	       (string= emacs-version "21.3.1")
	       (string= emacs-version "21.4.1")))
      (uim-vertical-motion-exec n)
    (vertical-motion n)))



;; startendޤǡɥǲʬΥƤ뤫
(defun uim-vertical-distance (start end)
  (let (dist1 dist2)
    (setq dist1 (uim-relative-vertical-count start))
    (setq dist2 (uim-relative-vertical-count end))
    (- dist2 dist1)))



;; ɥü餺ʸޤ֤ݤˤǤ֤
;;  δؿɬפʤΤXemacs-21꤫
(defun uim-pad-space (start end)
;  (uim-debug (format "uim-pad-space %d %d" start end))
  (let (strtmp pad ret eol (cnt 0))
    (save-excursion
      (while (> (uim-string-width (setq strtmp (buffer-substring start end))) (window-width))
	(setq strtmp (truncate-string-to-width strtmp (window-width)))
;	(uim-debug strtmp)
	(setq pad (- (window-width) (uim-string-width strtmp)))
	(setq cnt (+ cnt pad))
	(goto-char (+ start (length strtmp)))
	(insert-and-inherit (make-string pad 32))
	(setq start (point))
	(setq end (+ end pad))
	))
;    (uim-debug (format "uim-pad-space cnt: %d" cnt))
    cnt))



(defun uim-replace-tab (start end)
;  (uim-debug (format "uim-replace-tab %s %s" start end))
  (let (tpos (cnt 0) (ofs 0) tabwidth )
    (save-excursion
      (goto-char start)
      (while (setq tpos (search-forward "\t" end 1))
	;; ƬtabμޤǤtab̵
	(setq ofs (string-width (buffer-substring start (- tpos 1))))
	(setq tabwidth (- tab-width (% ofs tab-width)))
	(uim-debug (format "%d" tabwidth))
	(setq cnt (- (+ cnt tabwidth) 1))
	(goto-char tpos)
	(delete-backward-char 1)
	(insert-and-inherit (make-string tabwidth 32))
	(setq end (+ end tabwidth (- 1) ))
;	(uim-debug (format "tabwidth: %d, end: %d" tabwidth end))
	))
    cnt)) 





;; ԤȤ˽
(defun uim-tab-pad-space (start end)
;  (uim-debug (format "uim-tab-pad-space %d %d" start end))
  (let (org lstart lend (endorg end) tabspace)
    (setq org (point))
    (save-excursion
      (goto-char start)
      (catch 'line-loop
	(while (< (point) end)
	  (setq lstart (point))
	  (save-excursion
	    (end-of-line)
	    (if (> (point) end)
		(setq lend end)
	      (setq lend (point))))
	  (setq tabspace (uim-replace-tab lstart lend))
	  (setq end (+ end tabspace ))
	  (setq lend (+ lend tabspace))
	  (if (and uim-emacs
		   window-system
		   (>= emacs-major-version 21))
	      (setq end (+ end (uim-pad-space lstart lend))))
	  ;; fix lstart
	  (end-of-line)
	  (if (and (> (point-max) (point)) ;; not end of buffer
		   (< (point) end))       ;; not goal
	      (forward-char 1)
	    (throw 'line-loop t)))))
    (- end endorg)))


;; ɥߤʲ
(defun uim-update-window ()
  (let ((wstart (window-start)))
    (recenter)
    (set-window-start nil wstart nil)))

;; xemacsstring-widthк
(defun uim-string-width (str)
  (if (not uim-xemacs)
      (string-width str)
    (let ((start 0) (cnt 0))
      (while (setq start (string-match "\n" str start))
	(setq start (match-end 0))
	(setq cnt (- cnt 1)))
      (setq start 0)
      (while (setq start (string-match "\t" str start))
	(setq start (match-end 0))
	(setq cnt (+ cnt (- tab-width 1))))
      (+ (string-width str) cnt))))

(defun uim-format-string (str width &optional right)
  (if right
      (concat (make-string (- width (uim-string-width str)) 32) str)
    (concat str (make-string (- width (uim-string-width str)) 32))))



;; ꥹlst targetõơθadd­Τ֤
(defun uim-list-search-append (lst target add)
  (let ((new '()))
    (while lst
      (if (nlistp lst)
	  (setq new (append new lst))
	(if (nlistp (car lst))
	    (if (eq (car lst) target)
		(setq new (append new (list target add)))
	      (setq new (append new (list (car lst)))))

	  (setq new (append new (list (uim-list-search-append (car lst) target add))))))
      (if (listp lst)
	  (setq lst (cdr lst))
	(setq lst nil)))
    new))

;; ꥹlsttargetäΤ֤
(defun uim-list-search-delete (lst target)
  (let ((new '()) newtmp)
    (while lst
      (if (nlistp lst)
          (setq new (append new lst))
        (if (nlistp (car lst))
            (unless (eq (car lst) target)
              (setq new (append new (list (car lst)))))
          (setq newtmp (uim-list-search-delete (car lst) target))
          (if (not (equal newtmp nil))
              (setq new (append new (list newtmp))))))
      (if (listp lst)
          (setq lst (cdr lst))
        (setq lst nil )))
    new))


(provide 'uim-util)
